(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('rxjs'), require('rxjs/operators')) :
    typeof define === 'function' && define.amd ? define('angular-favicon', ['exports', '@angular/core', '@angular/common', 'rxjs', 'rxjs/operators'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['angular-favicon'] = {}, global.ng.core, global.ng.common, global.rxjs, global.rxjs.operators));
}(this, (function (exports, i0, i1, rxjs, operators) { 'use strict';

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () {
                            return e[k];
                        }
                    });
                }
            });
        }
        n['default'] = e;
        return Object.freeze(n);
    }

    var i0__namespace = /*#__PURE__*/_interopNamespace(i0);
    var i1__namespace = /*#__PURE__*/_interopNamespace(i1);

    /**
     * @fileoverview added by tsickle
     * Generated from: lib/angular-favicon.service.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * A service to set the favicon.
     */
    var AngularFaviconService = /** @class */ (function () {
        /**
         * @param {?} _doc
         * @param {?} rendererFactory
         */
        function AngularFaviconService(_doc, rendererFactory) {
            var _this = this;
            this._doc = _doc;
            this.rendererFactory = rendererFactory;
            this.darkScheme = '(prefers-color-scheme:dark)';
            this.prefersColorScheme$ = rxjs.fromEventPattern(( /**
             * @param {?} handler
             * @return {?}
             */function (/**
             * @param {?} handler
             * @return {?}
             */ handler) { return window.matchMedia(_this.darkScheme).addListener(( /** @type {?} */(handler))); })).pipe(operators.pluck('matches'));
            this.renderer = rendererFactory.createRenderer(null, null);
        }
        /**
         * Get the favicon of the current HTML document.
         * @return {?}
         */
        AngularFaviconService.prototype.getFavicon = function () {
            return this._doc.querySelector("link[rel*='icon']");
        };
        /**
         * Set the title of the current HTML document.
         * @param {?} iconURL - Default favicon URL
         * @param {?=} altIconURL - Optional, dark theme favicon URL
         * @return {?}
         */
        AngularFaviconService.prototype.setFavicon = function (iconURL, altIconURL) {
            /** @type {?} */
            var link = this.getFavicon() || this.renderer.createElement('link');
            /** @type {?} */
            var currentLinkHref = iconURL;
            if (altIconURL) {
                this.subscribeToChangesInTheme(link, iconURL, altIconURL);
                if (window.matchMedia(this.darkScheme).matches) {
                    currentLinkHref = altIconURL;
                }
            }
            this.appendLinkTag(link, currentLinkHref);
        };
        /**
         * Subscribe to the theme color changes in browser/OS and apply the appropiate favicon
         * @private
         * @param {?} link - DOM element
         * @param {?} iconURL - Default favicon URL
         * @param {?} altIconURL - Optional, dark theme favicon URL
         * @return {?}
         */
        AngularFaviconService.prototype.subscribeToChangesInTheme = function (link, iconURL, altIconURL) {
            var _this = this;
            this.subscriptionToColorScheme = this.prefersColorScheme$.subscribe(( /**
             * @param {?} isDarkTheme
             * @return {?}
             */function (/**
             * @param {?} isDarkTheme
             * @return {?}
             */ isDarkTheme) {
                if (isDarkTheme) {
                    _this.appendLinkTag(link, altIconURL);
                }
                else {
                    _this.appendLinkTag(link, iconURL);
                }
            }));
        };
        /**
         * Append new link to HEAD
         * @private
         * @param {?} link - DOM element
         * @param {?} iconURL - favicon URL
         * @return {?}
         */
        AngularFaviconService.prototype.appendLinkTag = function (link, iconURL) {
            link.type = 'image/x-icon';
            link.rel = 'shortcut icon';
            link.href = iconURL;
            /** @type {?} */
            var head = this._doc.getElementsByTagName('head')[0];
            this.renderer.appendChild(head, link);
        };
        /**
         * @return {?}
         */
        AngularFaviconService.prototype.ngOnDestroy = function () {
            if (this.subscriptionToColorScheme) {
                this.subscriptionToColorScheme.unsubscribe();
            }
        };
        return AngularFaviconService;
    }());
    AngularFaviconService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    AngularFaviconService.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: i0.Inject, args: [i1.DOCUMENT,] }] },
        { type: i0.RendererFactory2 }
    ]; };
    /** @nocollapse */ AngularFaviconService.ɵprov = i0__namespace.ɵɵdefineInjectable({ factory: function AngularFaviconService_Factory() { return new AngularFaviconService(i0__namespace.ɵɵinject(i1__namespace.DOCUMENT), i0__namespace.ɵɵinject(i0__namespace.RendererFactory2)); }, token: AngularFaviconService, providedIn: "root" });
    if (false) {
        /**
         * @type {?}
         * @private
         */
        AngularFaviconService.prototype.renderer;
        /**
         * @type {?}
         * @private
         */
        AngularFaviconService.prototype.darkScheme;
        /**
         * @type {?}
         * @private
         */
        AngularFaviconService.prototype.subscriptionToColorScheme;
        /**
         * @type {?}
         * @private
         */
        AngularFaviconService.prototype.prefersColorScheme$;
        /**
         * @type {?}
         * @private
         */
        AngularFaviconService.prototype._doc;
        /**
         * @type {?}
         * @private
         */
        AngularFaviconService.prototype.rendererFactory;
    }

    /**
     * @fileoverview added by tsickle
     * Generated from: public-api.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * Generated from: angular-favicon.ts
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.AngularFaviconService = AngularFaviconService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=angular-favicon.umd.js.map
