import { OnDestroy, RendererFactory2 } from '@angular/core';
/**
 * A service to set the favicon.
 */
export declare class AngularFaviconService implements OnDestroy {
    private _doc;
    private rendererFactory;
    private renderer;
    constructor(_doc: any, rendererFactory: RendererFactory2);
    private darkScheme;
    private subscriptionToColorScheme;
    private prefersColorScheme$;
    /**
     * Get the favicon of the current HTML document.
     */
    getFavicon(): any;
    /**
     * Set the title of the current HTML document.
     * @param iconURL - Default favicon URL
     * @param altIconURL - Optional, dark theme favicon URL
     */
    setFavicon(iconURL: string, altIconURL?: string): void;
    /**
     * Subscribe to the theme color changes in browser/OS and apply the appropiate favicon
     * @param link - DOM element
     * @param iconURL - Default favicon URL
     * @param altIconURL - Optional, dark theme favicon URL
     */
    private subscribeToChangesInTheme;
    /**
     * Append new link to HEAD
     * @param link - DOM element
     * @param iconURL - favicon URL
     */
    private appendLinkTag;
    ngOnDestroy(): void;
}
